Attribute VB_Name = "comm32"
Option Explicit

' cba\
Type DCB
    DCBlength As Long
    BaudRate As Long
    fDCB As Long
'    fBinary 1
'    fParity 2
'    fOutxCtsFlow 4
'    fOutxDsrFlow 8
'    fDtrControl 1
'    fDsrSensitivity 10
'    fTXContinueOnXoff 20
'    fOutX 40
'    fInX 80
'    fErrorChar 100
'    fNull 200
'    fRtsControl 400
'    fAbortOnError 800
'    fDummy2 1000
    wReserved As Integer
    XonLim As Integer
    XoffLim As Integer
    ByteSize As Byte
    Parity As Byte
    StopBits As Byte
    XonChar As Byte
    XoffChar As Byte
    ErrorChar As Byte
    EofChar As Byte
    EvtChar As Byte
End Type

' bnlrs`s\
Type COMSTAT
    fCOMSTAT As Long
'    fDsrHold 1
'    fRlsdHold 2
'    fXoffHold 4
'    fXoffSent 8
'    fEof 10
'    fTxim 20
'    fReserved 40-8000
    cbInQue As Long
    cbOutQue As Long
End Type

Type OFSTRUCT
    cBytes As Byte
    fFixedDisk As Byte
    nErrCode As Byte
    Reserved1 As Integer
    Reserved2 As Integer
    szPathName(1) As Byte
End Type

Type COMMTIMEOUTS
    ReadIntervalTimeOut As Long
    ReadTotalTimeOutMultiplier As Long
    ReadTotalTimeOutConstant As Long
    WriteTotalTimeOutMultiplier As Long
    WriteTotalTimeOutConstant As Long
End Type

Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Long
    bInheritHandle As Long
End Type

Global hCommDev&

' ʐM32`oh
Declare Function CreateFile Lib "Kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess&, ByVal dwShareMode&, lpSecurityAttributes As Any, ByVal dwCreationDistribution&, ByVal dwFlagsAndAttributes&, hTemplateFile As Any) As Long
Declare Function SetupComm Lib "Kernel32" (ByVal hCommDev&, ByVal cbInQueue&, ByVal cbOutQueue&) As Long
Declare Function CloseHandle Lib "Kernel32" (ByVal hCommDev&) As Long
Declare Function ReadFile Lib "Kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nBytesToRead&, lpNumberOfBytesRead&, lpOverlapped As Any) As Long
Declare Function WriteFile Lib "Kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nBytesToWrite&, lpNumberOfBytesWritten&, lpOverlapped As Any) As Long
'Declare Function WriteFile Lib "Kernel32" (ByVal hFile As Long, ByVal lpBuffer As String, ByVal nBytesToWrite&, lpNumberOfBytesWritten&, lpOverlapped As Any) As Long
Declare Function BuildCommDCB Lib "Kernel32" Alias "BuildCommDCBA" (ByVal lpszDef As String, lpdcb As DCB) As Long
Declare Function BuildCommDCBAndTimeouts Lib "Kernel32" (ByVal lpszDef As String, lpdcb As DCB, lpcto As COMMTIMEOUTS) As Long
Declare Function CloseFile Lib "netapi32" (ByVal idComDev As Integer) As Integer
Declare Function OpenFile Lib "Kernel32" (ByVal lpszDevControl As String, lpofstruct As OFSTRUCT, ByVal cbOutQueue As Integer) As Integer
Declare Function ClearCommBreak Lib "Kernel32" (ByVal hFile As Long) As Long
Declare Function ClearCommError Lib "Kernel32" (ByVal hFile As Long, lpErrors&, lpStat As COMSTAT) As Long
Declare Function GetCommState Lib "Kernel32" (ByVal hFile As Long, lpdcb As DCB) As Long
Declare Function SetCommState Lib "Kernel32" (ByVal hFile As Long, lpdcb As DCB) As Long
Declare Function SetCommTimeouts Lib "Kernel32" (ByVal hFile As Long, lpdcb As COMMTIMEOUTS) As Long
Declare Function GetCommTimeouts Lib "Kernel32" (ByVal hFile As Long, lpdcb As COMMTIMEOUTS) As Long
Declare Function EscapeCommFunction Lib "Kernel32" (ByVal hFile As Long, ByVal dwFunc As Long) As Long
Declare Function GetCommMask Lib "Kernel32" (ByVal hFile As Long, lpEvtMask As Long) As Long
Declare Function SetCommMask Lib "Kernel32" (ByVal hFile As Long, lpEvtMask As Long) As Long
Declare Function GetLastError Lib "Kernel32" () As Long
Declare Function PurgeComm Lib "Kernel32" (ByVal hFile As Long, ByVal fdwAction As Long) As Long
Declare Function GetExpandedName Lib "Kernel32" Alias "GetExpandedNameA" (ByVal lpFileName As String, ByVal lpszBuffer As String) As Long
Declare Function GetFinalPathNameByHandle Lib "Kernel32" Alias "GetFinalPathNameByHandleA" (ByVal hFile As Long, ByVal lpFileName As String, cchFilePath&, dwFlags&) As Long
Declare Function GetFullPathName Lib "Kernel32" Alias "GetFullPathNameA" (ByVal lpFileName As String, nBufferLength&, ByVal lpBuffer As String, ByVal lpFileName As String) As Long
Declare Function GetVolumeInformation Lib "Kernel32" Alias "GetVolumeInformationA" ( _
    ByVal RootPathName As String, _
    ByVal VolumeName As String, _
    ByVal VolumeNameSize As Long, _
    ByRef SerialNumber As Long, _
    ByRef MaxFileLen As Long, _
    ByRef FileSystemFlags As Long, _
    ByVal FileSystemName As String, _
    ByVal FileSystemNameSize As Long) As Long



Global Dummy&, DumStr0(12000) As Byte

'-----------------------------------------------------------
' ʂɎgp萔Eϐ
'-----------------------------------------------------------
  Global Const CommRXBuffSize = 9600  'Mobt@TCY
  Global Const CommTXBuffSize = 1280   'Mobt@TCY
'  Global Const EV_MASK = &H3FF         '}XNCxg
  Global CommDCB As DCB                   'ʐM|[ĝcba
  Global CommStat As COMSTAT              'ʐMԏ
  Global CommCTO As COMMTIMEOUTS              'ʐMԏ

  Global Const GENERIC_READ = &H80000000
  Global Const GENERIC_WRITE = &H40000000
  Global Const GENERIC_EXECUTE = &H20000000
  Global Const GENERIC_ALL = &H10000000

  Global Const FILE_SHARE_READ = &H1
  Global Const FILE_SHARE_WRITE = &H2
  Global Const FILE_ATTRIBUTE_READONLY = &H1
  Global Const FILE_ATTRIBUTE_HIDDEN = &H2
  Global Const FILE_ATTRIBUTE_SYSTEM = &H4
  Global Const FILE_ATTRIBUTE_DIRECTORY = &H10
  Global Const FILE_ATTRIBUTE_ARCHIVE = &H20
  Global Const FILE_ATTRIBUTE_NORMAL = &H80
  Global Const FILE_ATTRIBUTE_TEMPORARY = &H100
  Global Const FILE_ATTRIBUTE_COMPRESSED = &H800
  Global Const CREATE_NEW = 1
  Global Const CREATE_ALWAYS = 2
  Global Const OPEN_EXISTING = 3
  Global Const OPEN_ALWAYS = 4
  Global Const TRUNCATE_EXISTING = 5


'      ʂɎgp萔Eϐ

'      Rg[zԍɑΉʎq
  Global Const PORT1 = 0            '|[gP
  Global Const PORT2 = 1            '|[gQ
  Global Const PORT3 = 2            '|[gQ
  Global Const STOPS1 = 0           '1 Xgbvrbg
  Global Const STOPS2 = 1           '2 Xgbvrbg

'     ʐMp[^
  Global RSPort As Integer          '|[gԍ
  Global Baud As Integer            '{[[g
  Global Size As Integer            'f[^
  Global Stops As Integer           'Xgbvrbg
  Global Parity As Integer          'peB
  Global Xflow As Integer           'wt[
  Global RxCRLF As Integer          'MCR->CR/LFϊ
  Global TxCRLF As Integer          'MCR->CR/LFϊ
  Global Connected As Integer       'ڑԃtO
  Global RxLen As Integer
  Global CrPos As Integer
  Global RxBuffer As String
  Global Txbuffer As String

'     ʐM`ohQƂ萔
  Global Const SETXOFF = 1          'XOFF M̃G~[g
  Global Const SETXON = 2           'XON M̃G~[g
  Global Const SETRTS = 3           'RTS M𑗂
  Global Const CLRRTS = 4           'RTS MNA
  Global Const SETDTR = 5           'DTR M𑗂
  Global Const CLRDTR = 6           'DTR MNA
  Global Const RESETDEV = 7         'v^ foCXZbg
  Global Const SETBREAK = 8        'Set the device break line
  Global Const CLRBREAK = 9        'Clear the device break line

  Global Const CE_RXOVER = 1        'ML[̃I[ot[
  Global Const CE_OVERRUN = 2       'I[o[ G[o
  Global Const CE_RXPARITY = 4      'peB G[o
  Global Const CE_FRAME = 8         't[~O G[o
  Global Const CE_BREAK = &H10      'u[NԂo
  Global Const CE_TXFULL = &H100    'ML[ɋ󂫂Ȃ
  Global Const CE_PTO = &H200       'pƂ̒ʐMŃ^CAEg
  Global Const CE_IOE = &H400       'p foCXI/OG[
  Global Const CE_DNS = &H800       'p foCXIꂸ
  Global Const CE_OOP = &H1000      'p foCX̗p؂
  Global Const CE_MODE = &H8000     'vꂽ[hT|[gȂ
'  Global Const CE_CTSTO = &H20      'CTS ^CAEg
'  Global Const CE_DSRTO = &H40      'DSR ^CAEg
'  Global Const CE_RLSDTO = &H80     'RLSD ^CAEg

  Global Const IE_BADID = -1        'ʎqAT|[gȂ
  Global Const IE_OPEN = -2         'foCX̓I[vĂ
  Global Const IE_NOPEN = -3        'foCXI[vĂ܂
  Global Const IE_MEMORY = -4       '֐L[蓖ĂȂ
  Global Const IE_DEFAULT = -5      'ftHg̃p[^ԈႢ
  Global Const IE_HARDWARE = -10    'n[hEFAps\
  Global Const IE_BYTESIZE = -11    'w肳ꂽoCg TCYł
  Global Const IE_BAUDRATE = -12    'w̃{[[g̓T|[gȂ

  Global Const EV_RXCHAR = 1        'ML[ɒuꂽƂ
  Global Const EV_RXFLAG = 2        'CxgML[ɒuꂽ
  Global Const EV_TXEMPTY = 4       'ML[̍Ō̕ꂽ
  Global Const EV_CTS = 8           'CTS MύX
  Global Const EV_DSR = &H10        'DSR MύX
  Global Const EV_RLSD = &H20       'RLSD MύX
  Global Const EV_BREAK = &H40      '̓u[No
  Global Const EV_ERR = &H80        'C Xe[^X G[
  Global Const EV_RING = &H100      'O CWP[^̏Ԃ
  Global Const EV_PERR = &H200      'v^ G[o
  Global Const EV_RX80FULL = &H400
  Global Const EV_EVENT1 = &H800
  Global Const EV_EVENT2 = &H1000
'  Global Const EV_RingTe = &H2000

  Global Const NOPARITY = 0         'peBȂ
  Global Const ODDPARITY = 1        '
  Global Const EVENPARITY = 2       '
  Global Const MARKPARITY = 3       '}[N

  Global Const ONESTOPBIT = 0       '1rbg
  Global Const ONE5STOPBITS = 1     '1.5rbg
  Global Const TWOSTOPBITS = 2      '2rbg
   
  Global Const CSTF_CTSHOLD = 1     'CTS ҂
  Global Const CSTF_DSRHOLD = 2     'DSR ҂
  Global Const CSTF_RLSDHOLD = 4    'RLSD ҂
  Global Const CSTF_XOFFHOLD = 8    'XOFF Mɂ҂
  Global Const CSTF_XOFFSENT = &H10 'XOFF Mɂ҂
  Global Const CSTF_EOF = &H20      'EOF󂯎
  Global Const CSTF_TXIM = &H40     ']҂

  Global Const IGNORE = 0
  Global Const INFINITE = &HFFFF
'*
'* ֐:GetUseComNo
'* @:Ȃ
'* ߂l:Comԍ޲ؽ( vbCrLf؂)
'*
Public Function GetUseComNo() As String
    Dim Serial        As Object
    Dim SerialSet     As Object
    Dim objWMIService As Object
    Dim strComputer   As String
    Dim intCnt        As Integer    'vf
    Dim strComName    As String     '擾foCX

    strComputer = "."
    'WMIĂяo
    Set objWMIService = GetObject("winmgmts:\\" & strComputer & "\root\cimv2")

    '̌NG[s
    'NG[Pig{[h͎擾ł邪traVA擾łȂIj
    '* VA|[gɓo^Ă
    '* Set SerialSet = objWMIService.ExecQuery("Select * from Win32_SerialPort")

    'NG[QiVA|[gȊÔ̂ło\
    '* PnPœo^ẮifoCX}l[WṒj
    '* OɁu(COMxx)vƕtĂ̂𒊏o
    '* Set SerialSet = objWMIService.ExecQuery("Select * from Win32_PNPEntity " & _
                    "Where (Name like '%(COM%)')")

    'NG[RiŖȁHj
    'PnPœo^ẮifoCX}l[WṒj
    'VA|[g̃NXłOɁu(COMxx)vƕtĂ̂𒊏o
    Set SerialSet = objWMIService.ExecQuery("Select * from Win32_PNPEntity Where " & _
                    "(ClassGuid = '{4D36E978-E325-11CE-BFC1-08002BE10318}') and " & _
                    "(Name like '%(COM%)')")

    'S|[g̐(擾łڐ)
    intCnt = SerialSet.Count

    '̎擾
    strComName = ""
    For Each Serial In SerialSet
        'foCX擾 u"ʐM|[g (COM1)"v
        If strComName <> "" Then
            strComName = strComName & vbCrLf
        End If
        strComName = strComName & Serial.Name
    Next

    '߂lZbg
    GetUseComNo = strComName
End Function




Sub RSClose(hPort&)           '|[g
  Dim ret As Long

  If Connected = True Then
    ret = CloseHandle(hPort)     'ʐM|[gN[Y
    If ret = 1 Then              'TrueƂ܂Ȃ
      Connected = False
'      MsgBox "ڑؒf܂B", MB_OK
     Else
      MsgBox "ʐM|[g̃N[YɎs܂B", MB_ICONEXCLAMATION
    End If
  End If
End Sub

Sub RSEnd()
  RSClose (hCommDev)          '|[gN[Y(n܂)
'    ̧قRS232ݒf[^
  Call WriteIniProfile("COM", "COMPORT", Str$(RSPort))
  Call WriteIniProfile("COM", "BAUDRATE", Str$(Baud))
  Call WriteIniProfile("COM", "DATASIZE", Str$(Size))
  Call WriteIniProfile("COM", "STOPBIT", Str$(Stops))
  Call WriteIniProfile("COM", "PARITY", Str$(Parity))
  Call WriteIniProfile("COM", "XFLOW", Str$(Xflow))
  Call WriteIniProfile("COM", "RxCRLF", Str$(RxCRLF))
  Call WriteIniProfile("COM", "TxCRLF", Str$(TxCRLF))
End Sub

Sub RSInit()         '̧قRS232ݒްǍ
  Connected = False
  RSPort = GetIniProfileInt("COM", "COMPORT", PORT1)
  Baud = GetIniProfileInt("COM", "BAUDRATE", 3)
  Size = GetIniProfileInt("COM", "DATASIZE", 1)
  Stops = GetIniProfileInt("COM", "STOPBIT", STOPS1)
  Parity = GetIniProfileInt("COM", "PARITY", EVENPARITY)
  Xflow = GetIniProfileInt("COM", "XFLOW", UNCHECKED)
  RxCRLF = GetIniProfileInt("COM", "RxCRLF", UNCHECKED)
  TxCRLF = GetIniProfileInt("COM", "TxCRLF", Checked)
End Sub

Function RSLoc&(hPort&)               'ML𒲍
  Dim ret As Long, ErrorMask As Long
  
  ret = ClearCommError(hPort, ErrorMask, CommStat) ' Mobt@̕擾
  RSLoc = CommStat.cbInQue              ' ߂lݒ
End Function

Function RSOpen&()
  Dim SetStr As String
  Dim rep As String * 120
  Dim rep0 As String * 120
  Dim ret&, i&, Dummy&

  If Connected = True Then
    MsgBox "|[g͂łɃI[vĂ܂B"
    Exit Function
   Else
    Do
      Select Case RSPort               'p[^ݒ
        Case PORT1
          SetStr = "com1" & Chr$(0)
        Case PORT2
          SetStr = "com2" & Chr$(0)
        Case PORT3
          SetStr = "com3" & Chr$(0)
        Case 3
          SetStr = "com4" & Chr$(0)
        Case 4
          SetStr = "com5" & Chr$(0)
        Case 5
          SetStr = "com6" & Chr$(0)
        Case 6
          SetStr = "com7" & Chr$(0)
        Case 7
          SetStr = "com8" & Chr$(0)
        Case 8
          SetStr = "com9" & Chr$(0)
        Case 9
          SetStr = "\\.\com10" & Chr$(0)
        Case 10
          SetStr = "\\.\com11" & Chr$(0)
        Case 11
          SetStr = "\\.\com12" & Chr$(0)
        Case 12
          SetStr = "\\.\com13" & Chr$(0)
        Case 13
          SetStr = "\\.\com14" & Chr$(0)
        Case 14
          SetStr = "\\.\com15" & Chr$(0)
        Case 15
          SetStr = "\\.\com16" & Chr$(0)
        Case 16
          SetStr = "\\.\com17" & Chr$(0)
        Case 17
          SetStr = "\\.\com18" & Chr$(0)
        Case 18
          SetStr = "\\.\com19" & Chr$(0)
        Case 19
          SetStr = "\\.\com20" & Chr$(0)
        Case 20
          SetStr = "\\.\com21" & Chr$(0)
        Case 21
          SetStr = "\\.\com22" & Chr$(0)
        Case 22
          SetStr = "\\.\com23" & Chr$(0)
        Case 23
          SetStr = "\\.\com24" & Chr$(0)
        Case 24
          SetStr = "\\.\com25" & Chr$(0)
        Case 25
          SetStr = "\\.\com26" & Chr$(0)
        Case 26
          SetStr = "\\.\com27" & Chr$(0)
        Case 27
          SetStr = "\\.\com28" & Chr$(0)
        Case 28
          SetStr = "\\.\com29" & Chr$(0)
      End Select
      hCommDev = CreateFile(SetStr, GENERIC_READ Or GENERIC_WRITE, 0, ByVal 0&, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, ByVal 0&)
      If hCommDev <= 0 Then
        i = MsgBox("ݒ̃|[gJƂo܂BIɊJ܂H", MB_YESNO)
        Select Case i
          Case IDYES
            hCommDev = CDbl(GetIniProfile("COM", "hCommDev"))
            Exit Do
          Case IDNO
            Rsset32.Show 1
'            End                          'AvP[VI
        End Select
       Else
'        MsgBox "|[gJ܂"
        Call WriteIniProfile("COM", "hCommDev", Str$(hCommDev))
        Exit Do
      End If
    Loop
  End If

'  ret = GetFinalPathNameByHandle(hCommDev, rep, 100, 0)
'  ret = GetFullPathName(SetStr, 100, rep, rep0)


  If SetupComm(hCommDev, 12800, 1200) = True Then
    MsgBox "ʐM|[g̏Ɏs܂"
    End
  End If
  ret = GetCommState(hCommDev, CommDCB)
  Select Case Baud
    Case 7
      CommDCB.BaudRate = 56000    '{[[g̒ǉ
    Case 8
      CommDCB.BaudRate = 57600    '{[[g̒ǉ
    Case 9
      CommDCB.BaudRate = 115200    '{[[g̒ǉ
    Case 10
'      CommDCB.BaudRate = 128000    '{[[g̒ǉ
    Case 11
'      CommDCB.BaudRate = 256000    '{[[g̒ǉ
    Case Else
      CommDCB.BaudRate = 600 * 2 ^ Baud    '{[[g̒ǉ
  End Select
  CommDCB.ByteSize = 7 + Size          'oCg̃rbg̒ǉ
  CommDCB.Parity = Parity              'peB̒ǉ
  Select Case Stops
    Case 0
      CommDCB.StopBits = ONESTOPBIT    'Xgbvrbg̒ǉ
    Case 1
      CommDCB.StopBits = TWOSTOPBITS   'Xgbvrbg̒ǉ
  End Select
  
  Select Case Xflow                     'wt[
    Case 1
      CommDCB.XonChar = Chr$(&H11)
      CommDCB.XoffChar = Chr$(&H13)
      CommDCB.XonLim = 100
      CommDCB.XoffLim = 100
      CommDCB.fDCB = CommDCB.fDCB Or &H300    'fOutX, fInX on
    Case 0
      CommDCB.fDCB = CommDCB.fDCB And &HFCFF  'fOutX, fInX off
  End Select

        ' ʐMp[^̐ݒ
  ret = SetCommState(hCommDev, CommDCB)
  If ret = False Then
    Dummy = CloseHandle(hCommDev)
    Connected = False              'G[
    RSOpen = ret
    Exit Function
  End If
  
  CommCTO.ReadIntervalTimeOut = 100
  CommCTO.ReadTotalTimeOutMultiplier = 1          'ڑmFp
  CommCTO.ReadTotalTimeOutConstant = 100
  CommCTO.WriteTotalTimeOutMultiplier = 1
  CommCTO.WriteTotalTimeOutConstant = 100
  ret = SetCommTimeouts(hCommDev, CommCTO)

'  Dummy = EscapeCommFunction(RSPort, SETDTR)    ' DTR M ON

  Connected = True
  RSOpen = True                       '߂lݒ
End Function

Function RSRead&(hPort&, RxBuffer() As Byte)       'M()
  Dim ret As Long
  Dim ErrorMask As Long
  Dim i As Long
  Dim Dummy As Long
  Dim RxLen As Long
  Dim Count As Long
  Dim RxDum(12000) As Byte

  ret = ClearCommError(hPort, ErrorMask, CommStat) ' Mobt@̕擾
  If CommStat.cbInQue > 0 Then
    RxDum(0) = 0        'MǍ
    ret = ReadFile(hPort, RxDum(0), CommStat.cbInQue, RxLen, ByVal 0&)
    If ret = False Then
      RxDum(0) = 0                           'G[
      Dummy = ClearCommError(hPort, ErrorMask, CommStat)
      ret = False
      Exit Function
    End If
    For i = 1 To RxLen
      RxBuffer(Count) = RxDum(i - 1)
      Count = Count + 1
    Next
  End If
  RSRead = Count                       '߂lݒ
End Function

Function RSReadNum&(hPort&, RxBuffer() As Byte, Num&)      'NumM()
  Dim ret As Long
  Dim ErrorMask As Long
  Dim i As Long
  Dim Dummy As Long
  Dim RxLen As Long
  Dim Count As Long
  Dim RxDum(12000) As Byte

  Dummy = GetTickCount() + 1000 + (2 * (Num And &H3FF))
  Do
    ret = ClearCommError(hPort, ErrorMask, CommStat) ' Mobt@̕擾
    DoEvents
  Loop Until (CommStat.cbInQue >= Num) Or (Dummy < GetTickCount())
  RxDum(0) = 0        'MǍ
  ret = ReadFile(hPort, RxDum(0), CommStat.cbInQue, RxLen, ByVal 0&)
  If ret = False Then
    RxDum(0) = 0                           'G[
    Dummy = ClearCommError(hPort, ErrorMask, CommStat)
    ret = False
    Exit Function
  End If
  For i = 1 To RxLen
    RxBuffer(Count) = RxDum(i - 1)
    Count = Count + 1
  Next
  If Count = Num Then
    RSReadNum = Count                       '߂lݒ
   Else
    RSReadNum = False                       '߂lݒ
  End If
End Function


Function RSReadLine&(hPort&, RxBuffer() As Byte) 'M(ĂȂ܂ŎM)
  Dim ret As Long
  Dim ErrorMask As Long
  Dim i As Long
  Dim Dummy As Long
  Dim RxLen As Long
  Dim Count As Long
  Dim RxDum(12000) As Byte

  Do
    ret = ClearCommError(hPort, ErrorMask, CommStat) ' Mobt@̕擾
    Select Case CommStat.cbInQue
      Case 0                       'G[
        ret = Count
'        For Dummy = 0 To RET - 1
 '         RxBuffer(Dummy) = AscB(MidB(StrConv(DUMStr, vbFromUnicode), Dummy + 1, 1))
  '      Next
        Exit Do
      Case Is > 0                        'Ms
        RxDum(0) = 0        'MǍ
        ret = ReadFile(hPort, RxDum(0), CommStat.cbInQue, RxLen, ByVal 0&)
        If ret = False Then
          RxBuffer = ""                           'G[
          Dummy = ClearCommError(hPort, ErrorMask, CommStat)
          ret = False
          Exit Function
        End If
        For i = 1 To RxLen
          RxBuffer(Count) = RxDum(i - 1)
          Count = Count + 1
        Next
    End Select
    
    WAIT 170                             'M҂170mS
  Loop
    
  RSReadLine = ret                       '߂lݒ
End Function


Sub RSSendA(Dum() As Byte, DatLen As Long)  'Dum As String)
  Dim Dummy As Long
  Dim Txbuffer As String
  
  If IgnoreFlg <> 0 Then Exit Sub   'Ił̂łٰ݂pX
  Do
    If WriteFile(hCommDev, Dum(0), DatLen, Dummy, ByVal 0&) = False Then
      Dummy = MsgBox("@͐ɐڑĂ܂Hs𑱍s܂H", MB_ABORTRETRYIGNORE)
      Select Case Dummy
        Case IDABORT
          RSClose (hCommDev)                            'Iw
          End
        Case IDRETRY                                  'JԂ(ꍇ)
        Case IDIGNORE
          IgnoreFlg = 1                               'I񂾏ꍇٰ݂pX
          Exit Do
      End Select
     Else
      Exit Do
    End If
  Loop

End Sub

Sub RSSend(Dum As String)           '𑗐M
  Dim Dummy As Long
  Dim Txbuffer As String
  
  If IgnoreFlg <> 0 Then Exit Sub   'Ił̂łٰ݂pX
  Do
    Txbuffer = Dum & Chr$(&HD) & Chr$(0)
'    Txbuffer = Dum & Chr$(&HA) & Chr$(0)
'    Txbuffer = Dum & Chr$(&HD) & Chr$(&HA) & Chr$(0)
    If WriteFile(hCommDev, ByVal Txbuffer, Len(Txbuffer) - 1, Dummy, ByVal 0&) = False Then
      Dummy = MsgBox("@͐ɐڑĂ܂Hs𑱍s܂H", MB_ABORTRETRYIGNORE)
      Select Case Dummy
        Case IDABORT
          RSClose (hCommDev)                            'Iw
          End
        Case IDRETRY                                  'JԂ(ꍇ)
        Case IDIGNORE
          IgnoreFlg = 1                               'I񂾏ꍇٰ݂pX
          Exit Do
      End Select
     Else
      Exit Do
    End If
  Loop
End Sub
Sub RSSendC(Dum As String)           '𑗐M
  Dim Dummy As Long
  Dim Txbuffer As String
  
  If IgnoreFlg <> 0 Then Exit Sub   'Ił̂łٰ݂pX
  Do
    Txbuffer = Dum & Chr$(0)
    If WriteFile(hCommDev, ByVal Txbuffer, Len(Txbuffer) - 1, Dummy, ByVal 0&) = False Then
      Dummy = MsgBox("@͐ɐڑĂ܂Hs𑱍s܂H", MB_ABORTRETRYIGNORE)
      Select Case Dummy
        Case IDABORT
          RSClose (hCommDev)                            'Iw
          End
        Case IDRETRY                                  'JԂ(ꍇ)
        Case IDIGNORE
          IgnoreFlg = 1                               'I񂾏ꍇٰ݂pX
          Exit Do
      End Select
     Else
      Exit Do
    End If
  Loop
End Sub


